/*------------------------------------------------*/
/* c23/sigaction.c                                */

#include <stdio.h>
#include <signal.h>

static int chyceni_signalu;

int a = 5, b = 0;

void zpracuj_signal(int cislo_signalu)
{
    chyceni_signalu++;
    struct sigaction sa;
    sigset_t set;


    switch (cislo_signalu) {
    case SIGFPE:
	printf("Delit nulou se nevyplaci! a= %i, b= %i, chyceni_signalu= %i\n",
		a, b, chyceni_signalu);
	break;
    default:
	printf("Neocekavany signal!\n");
	break;
    }
    if (chyceni_signalu >= 3) {
	printf("Uz toho mam dost!\n");
	sigemptyset(&set);
	sa.sa_handler = SIG_DFL;
	sa.sa_mask = set;
	sa.sa_flags = SA_RESTART;
	sa.sa_restorer = NULL;
	(void) sigaction(SIGFPE, &sa, NULL);
    }
}

int main(void)
{

    struct sigaction sb, sa;
    sigset_t set;

    sigemptyset(&set); /* inicializuje - vyprazdni set */
    sa.sa_handler = zpracuj_signal;
    sa.sa_mask = set;
    sa.sa_flags = SA_RESTART;
    sa.sa_restorer = NULL;

    (void) sigaction(SIGFPE, &sa, &sb);
    if(sb.sa_handler == SIG_DFL) {
    	printf("To je poprve, co nastavuji zpracovani signalu pro SIGFPE\n");
    }

    printf("Zaciname: \n");
    printf("Deleni: %i/%i=%i\n", a, b, a / b);
    printf("Tento text se jiz nevytiskne.");

    return 0;
}
/*------------------------------------------------*/
